--- asterisk-1.2-svn/apps/app_queue.c	2006-07-12 14:03:15.000000000 +0200
+++ asterisk-1.2-current/apps/app_queue.c	2006-07-12 16:41:34.000000000 +0200
@@ -353,7 +353,7 @@
 	char sound_thanks[80];          /*!< Sound file: "Thank you for your patience." (def. queue-thankyou) */
 	char sound_reporthold[80];	/*!< Sound file: "Hold time" (def. queue-reporthold) */
 	char sound_periodicannounce[80];/*!< Sound file: Custom announce, no default */
-
+	char sound_callerannounce[80];	/*!< Sound file: Custom announce for caller, no default */
 	int count;			/*!< How many entries */
 	int maxlen;			/*!< Max number of entries */
 	int wrapuptime;			/*!< Wrapup Time */
@@ -597,6 +597,7 @@
 	q->announce[0] = '\0';
 	q->context[0] = '\0';
 	q->monfmt[0] = '\0';
+	q->sound_callerannounce[0] = '\0';	/* Default, don't announce the caller that he has been answered*/
 	q->periodicannouncefrequency = 0;
 	ast_copy_string(q->sound_next, "queue-youarenext", sizeof(q->sound_next));
 	ast_copy_string(q->sound_thereare, "queue-thereare", sizeof(q->sound_thereare));
@@ -775,6 +776,8 @@
 		ast_copy_string(q->sound_periodicannounce, val, sizeof(q->sound_periodicannounce));
 	} else if (!strcasecmp(param, "periodic-announce-frequency")) {
 		q->periodicannouncefrequency = atoi(val);
+	} else if (!strcasecmp(param, "queue-callerannounce")) {
+		ast_copy_string(q->sound_callerannounce, val, sizeof(q->sound_callerannounce));
 	} else if (!strcasecmp(param, "retry")) {
 		q->retry = atoi(val);
 		if (q->retry < 0)
@@ -2352,6 +2359,11 @@
 			ast_hangup(peer);
 			return -1;
 		}
+		/* Play announcement to the caller telling it's his turn if defined*/
+		if (!ast_strlen_zero(qe->parent->sound_callerannounce)) {
+			if (play_file(qe->chan, qe->parent->sound_callerannounce))
+				ast_log(LOG_WARNING, "Announcement file '%s' is unavailable, continuing anyway...\n",qe->parent->sound_callerannounce);
+		}
 		/* Begin Monitoring */
 		if (qe->parent->monfmt && *qe->parent->monfmt) {
 			monitorfilename = pbx_builtin_getvar_helper(qe->chan, "MONITOR_FILENAME");
